Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Writer.pl	(revision 34921)
@@ -4938,6 +6397,8 @@
                         my $tagInfo = $Image::ExifTool::Extra{Comment};
                         my $nvHash = $self->GetNewValueHash($tagInfo);
-                        if (IsOverwriting($nvHash, $segData) or $$delGroup{File}) {
-                            $newComment = GetNewValues($nvHash);
+                        my $val = $segData;
+                        $val =~ s/\0+$//;   # allow for stupid software that adds NULL terminator
+                        if ($self->IsOverwriting($nvHash, $val) or $$delGroup{File}) {
+                            $newComment = $self->GetNewValue($nvHash);
                         } else {
                             delete $$editDirs{COM}; # we aren't editing COM after all
@@ -4947,5 +6408,5 @@
                 }
                 $self->VerboseValue('- Comment', $$segDataPt);
-                if (defined $newComment and length $newComment) {
+                if (defined $newComment) {
                     # write out the comments
                     $self->VerboseValue('+ Comment', $newComment);
@@ -4954,18 +6415,19 @@
                     $verbose and print $out "  Deleting COM segment\n";
                 }
-                ++$self->{CHANGED};     # increment the changed flag
+                ++$$self{CHANGED};      # increment the changed flag
                 undef $segDataPt;       # don't write existing comment
             }
             last;   # didn't want to loop anyway
         }
+
         # delete necessary segments (including unknown segments if deleting all)
         if ($del or ($$delGroup{'*'} and not $segType and $marker>=0xe0 and $marker<=0xef)) {
             $segType = 'unknown' unless $segType;
             $verbose and print $out "  Deleting $markerName $segType segment\n";
-            ++$self->{CHANGED};
+            ++$$self{CHANGED};
             next Marker;
         }
         # write out this segment if $segDataPt is still defined
-        if (defined $segDataPt) {
+        if (defined $segDataPt and defined $$segDataPt) {
             # write the data for this record (the data could have been
             # modified, so recalculate the length word)
@@ -4980,6 +6442,9 @@
             }
             undef $$segDataPt;  # free the buffer
-        }
-    }
+            undef $segDataPt;
+        }
+    }
+    # make sure the ICC_Profile was complete
+    $self->Error('Incomplete ICC_Profile record', 1) if defined $iccChunkCount;
     pop @$path if @$path > $pn;
     # if oldOutfile is still set, there was an error copying the JPEG
@@ -4992,4 +6457,8 @@
     # set return value to -1 if we only had a write error
     $rtnVal = -1 if $rtnVal and $err;
+    if ($creatingEXV and $rtnVal > 0 and not $$self{CHANGED}) {
+        $self->Error('Nothing written');
+        $rtnVal = -1;
+    }
     return $rtnVal;
 }
@@ -5005,5 +6474,5 @@
         $self->Options('IgnoreMinorErrors'))
     {
-        return '[minor] Not a valid image';
+        return '[Minor] Not a valid image';
     }
     return undef;
@@ -5073,5 +6542,5 @@
                     }
                 }
-                return 'Not a floating point number' 
+                return 'Not a floating point number';
             }
             if ($format =~ /^rational\d+u$/ and $val < 0) {
@@ -5111,4 +6580,153 @@
 
 #------------------------------------------------------------------------------
+# Rename a file (with patch for Windows Unicode file names, and other problem)
+# Inputs: 0) ExifTool ref, 1) old name, 2) new name
+# Returns: true on success
+sub Rename($$$)
+{
+    my ($self, $old, $new) = @_;
+    my ($result, $try, $winUni);
+
+    if ($self->EncodeFileName($old)) {
+        $self->EncodeFileName($new, 1);
+        $winUni = 1;
+    } elsif ($self->EncodeFileName($new)) {
+        $old = $_[1];
+        $self->EncodeFileName($old, 1);
+        $winUni = 1;
+    }
+    for (;;) {
+        if ($winUni) {
+            $result = eval { Win32API::File::MoveFileExW($old, $new,
+                Win32API::File::MOVEFILE_REPLACE_EXISTING() |
+                Win32API::File::MOVEFILE_COPY_ALLOWED()) };
+        } else {
+            $result = rename($old, $new);
+        }
+        last if $result or $^O ne 'MSWin32';
+        # keep trying for up to 0.5 seconds
+        # (patch for Windows denial-of-service susceptibility)
+        $try = ($try || 1) + 1;
+        last if $try > 50;
+        select(undef,undef,undef,0.01); # sleep for 0.01 sec
+    }
+    return $result;
+}
+
+#------------------------------------------------------------------------------
+# Delete a file (with patch for Windows Unicode file names)
+# Inputs: 0) ExifTool ref, 1-N) names of files to delete
+# Returns: number of files deleted
+sub Unlink($@)
+{
+    my $self = shift;
+    my $result = 0;
+    while (@_) {
+        my $file = shift;
+        if ($self->EncodeFileName($file)) {
+            ++$result if eval { Win32API::File::DeleteFileW($file) };
+        } else {
+            ++$result if unlink $file;
+        }
+    }
+    return $result;
+}
+
+#------------------------------------------------------------------------------
+# Set file times (Unix seconds since the epoch)
+# Inputs: 0) ExifTool ref, 1) file name or ref, 2) access time, 3) modification time,
+#         4) inode change or creation time (or undef for any time to avoid setting)
+#         5) flag to suppress warning
+# Returns: 1 on success, 0 on error
+my $k32SetFileTime;
+sub SetFileTime($$;$$$$)
+{
+    my ($self, $file, $atime, $mtime, $ctime, $noWarn) = @_;
+    my $saveFile;
+    local *FH;
+
+    # open file by name if necessary
+    unless (ref $file) {
+        # (file will be automatically closed when *FH goes out of scope)
+        unless ($self->Open(\*FH, $file, '+<')) {
+            my $success;
+            if (defined $atime or defined $mtime) {
+                my ($a, $m, $c) = $self->GetFileTime($file);
+                $atime = $a unless defined $atime;
+                $mtime = $m unless defined $mtime;
+                $success = eval { utime($atime, $mtime, $file) } if defined $atime and defined $mtime;
+            }
+            $self->Warn('Error opening file for update') unless $success;
+            return $success;
+        }
+        $saveFile = $file;
+        $file = \*FH;
+    }
+    # on Windows, try to work around incorrect file times when daylight saving time is in effect
+    if ($^O eq 'MSWin32') {
+        if (not eval { require Win32::API }) {
+            $self->WarnOnce('Install Win32::API for proper handling of Windows file times');
+        } elsif (not eval { require Win32API::File }) {
+            $self->WarnOnce('Install Win32API::File for proper handling of Windows file times');
+        } else {
+            # get Win32 handle, needed for SetFileTime
+            my $win32Handle = eval { Win32API::File::GetOsFHandle($file) };
+            unless ($win32Handle) {
+                $self->Warn('Win32API::File::GetOsFHandle returned invalid handle');
+                return 0;
+            }
+            # convert Unix seconds to FILETIME structs
+            my $time;
+            foreach $time ($atime, $mtime, $ctime) {
+                # set to NULL if not defined (i.e. do not change)
+                defined $time or $time = 0, next;
+                # convert to 100 ns intervals since 0:00 UTC Jan 1, 1601
+                # (89 leap years between 1601 and 1970)
+                my $wt = ($time + (((1970-1601)*365+89)*24*3600)) * 1e7;
+                my $hi = int($wt / 4294967296);
+                $time = pack 'LL', int($wt - $hi * 4294967296), $hi; # pack FILETIME struct
+            }
+            unless ($k32SetFileTime) {
+                return 0 if defined $k32SetFileTime;
+                $k32SetFileTime = new Win32::API('KERNEL32', 'SetFileTime', 'NPPP', 'I');
+                unless ($k32SetFileTime) {
+                    $self->Warn('Error calling Win32::API::SetFileTime');
+                    $k32SetFileTime = 0;
+                    return 0;
+                }
+            }
+            unless ($k32SetFileTime->Call($win32Handle, $ctime, $atime, $mtime)) {
+                $self->Warn('Win32::API::SetFileTime returned ' . Win32::GetLastError());
+                return 0;
+            }
+            return 1;
+        }
+    }
+    # other OS (or Windows fallback)
+    if (defined $atime and defined $mtime) {
+        my $success;
+        local $SIG{'__WARN__'} = \&SetWarning; # (this may not be necessary)
+        for (;;) {
+            undef $evalWarning;
+            # (this may fail on the first try if futimes is not implemented)
+            $success = eval { utime($atime, $mtime, $file) };
+            last if $success or not defined $saveFile;
+            close $file;
+            $file = $saveFile;
+            undef $saveFile;
+        }
+        unless ($noWarn) {
+            if ($@ or $evalWarning) {
+                $self->Warn(CleanWarning($@ || $evalWarning));
+            } elsif (not $success) {
+                $self->Warn('Error setting file time');
+            }
+        }
+        return $success;
+    }
+    return 1; # (nothing to do)
+}
+
+#------------------------------------------------------------------------------
 # Copy data block from RAF to output file in max 64kB chunks
 # Inputs: 0) RAF ref, 1) outfile ref, 2) block size
@@ -5129,5 +6747,5 @@
 
 #------------------------------------------------------------------------------
-# copy image data from one file to another
+# Copy image data from one file to another
 # Inputs: 0) ExifTool object reference
 #         1) reference to list of image data [ position, size, pad bytes ]
@@ -5137,5 +6755,5 @@
 {
     my ($self, $imageDataBlocks, $outfile) = @_;
-    my $raf = $self->{RAF};
+    my $raf = $$self{RAF};
     my ($dataBlock, $err);
     my $num = @$imageDataBlocks;
@@ -5158,5 +6776,5 @@
 
 #------------------------------------------------------------------------------
-# write to binary data block
+# Write to binary data block
 # Inputs: 0) ExifTool object ref, 1) source dirInfo ref, 2) tag table ref
 # Returns: Binary data block or undefined on error
@@ -5191,6 +6809,6 @@
     my $tagInfo;
     $dataPt = \$newData;
-    foreach $tagInfo ($self->GetNewTagInfoList($tagTablePtr)) {
-        my $tagID = $tagInfo->{TagID};
+    foreach $tagInfo (sort { $$a{TagID} <=> $$b{TagID} } $self->GetNewTagInfoList($tagTablePtr)) {
+        my $tagID = $$tagInfo{TagID};
         # evaluate conditional tags now if necessary
         if (ref $$tagTablePtr{$tagID} eq 'ARRAY' or $$tagInfo{Condition}) {
@@ -5199,7 +6817,7 @@
         }
         # add offsets for variable-sized tags if necessary
-        while (@varInfo and $varInfo[0] < $tagID) {
-            shift @varInfo;             # discard index
-            $varSize = shift @varInfo;  # get accumulated variable size
+        while (@varInfo and $varInfo[0][0] < $tagID) {
+            $varSize = $varInfo[0][1];  # get accumulated variable size
+            shift @varInfo;
         }
         my $count = 1;
@@ -5222,17 +6840,21 @@
             $format = $defaultFormat;
         }
+        # read/write using variable format if changed in Hook
+        $format = $varInfo[0][2] if @varInfo and $varInfo[0][0] == $tagID;
         my $val = ReadValue($dataPt, $entry, $format, $count, $dirLen-$entry);
         next unless defined $val;
-        my $nvHash = $self->GetNewValueHash($tagInfo);
-        next unless IsOverwriting($nvHash, $val);
-        my $newVal = GetNewValues($nvHash);
+        my $nvHash = $self->GetNewValueHash($tagInfo, $$self{CUR_WRITE_GROUP});
+        next unless $self->IsOverwriting($nvHash, $val) > 0;
+        my $newVal = $self->GetNewValue($nvHash);
         next unless defined $newVal;    # can't delete from a binary table
+        # update DataMember with new value if necessary
+        $$self{$$tagInfo{DataMember}} = $newVal if $$tagInfo{DataMember};
         # only write masked bits if specified
         my $mask = $$tagInfo{Mask};
-        $newVal = ($newVal & $mask) | ($val & ~$mask) if defined $mask;
+        $newVal = (($newVal << $$tagInfo{BitShift}) & $mask) | ($val & ~$mask) if $mask;
         # set the size
         if ($$tagInfo{DataTag} and not $$tagInfo{IsOffset}) {
             warn 'Internal error' unless $newVal == 0xfeedfeed;
-            my $data = $self->GetNewValues($$tagInfo{DataTag});
+            my $data = $self->GetNewValue($$tagInfo{DataTag});
             $newVal = length($data) if defined $data;
             my $format = $$tagInfo{Format} || $$tagTablePtr{FORMAT} || 'int32u';
@@ -5245,5 +6867,5 @@
             $self->VerboseValue("- $dirName:$$tagInfo{Name}", $val);
             $self->VerboseValue("+ $dirName:$$tagInfo{Name}", $newVal);
-            ++$self->{CHANGED};
+            ++$$self{CHANGED};
         }
     }
@@ -5254,9 +6876,9 @@
         my $fixup = $$dirInfo{Fixup};
         my $tagID;
-        foreach $tagID (@{$tagTablePtr->{IS_OFFSET}}) {
+        foreach $tagID (@{$$tagTablePtr{IS_OFFSET}}) {
             $tagInfo = $self->GetTagInfo($tagTablePtr, $tagID) or next;
-            while (@varInfo and $varInfo[0] < $tagID) {
+            while (@varInfo and $varInfo[0][0] < $tagID) {
+                $varSize = $varInfo[0][1];
                 shift @varInfo;
-                $varSize = shift @varInfo;
             }
             my $entry = $tagID * $increment + $varSize; # (no offset to dirStart for new dir data)
@@ -5265,9 +6887,9 @@
             my $format = $$tagInfo{Format} || $$tagTablePtr{FORMAT} || 'int32u';
             my $offset = ReadValue($dataPt, $entry, $format, 1, $dirLen-$entry);
-            # ignore if offset is zero (ie. Ricoh DNG uses this to indicate no preview)
+            # ignore if offset is zero (eg. Ricoh DNG uses this to indicate no preview)
             next unless $offset;
             $fixup->AddFixup($entry, $$tagInfo{DataTag}, $format);
             # handle the preview image now if this is a JPEG file
-            next unless $self->{FILE_TYPE} eq 'JPEG' and $$tagInfo{DataTag} and
+            next unless $$self{FILE_TYPE} eq 'JPEG' and $$tagInfo{DataTag} and
                 $$tagInfo{DataTag} eq 'PreviewImage' and defined $$tagInfo{OffsetPair};
             # NOTE: here we assume there are no var-sized tags between the
@@ -5276,11 +6898,13 @@
             $entry = $$tagInfo{OffsetPair} * $increment + $varSize;
             my $size = ReadValue($dataPt, $entry, $format, 1, $dirLen-$entry);
-            my $previewInfo = $self->{PREVIEW_INFO};
-            $previewInfo or $previewInfo = $self->{PREVIEW_INFO} = { };
+            my $previewInfo = $$self{PREVIEW_INFO};
+            $previewInfo or $previewInfo = $$self{PREVIEW_INFO} = {
+                Fixup => new Image::ExifTool::Fixup,
+            };
             # set flag indicating we are using short pointers
             $$previewInfo{IsShort} = 1 unless $format eq 'int32u';
             $$previewInfo{Absolute} = 1 if $$tagInfo{IsOffset} and $$tagInfo{IsOffset} eq '3';
             # get the value of the Composite::PreviewImage tag
-            $$previewInfo{Data} = $self->GetNewValues($Image::ExifTool::Composite{PreviewImage});
+            $$previewInfo{Data} = $self->GetNewValue(GetCompositeTagInfo('PreviewImage'));
             unless (defined $$previewInfo{Data}) {
                 if ($offset >= 0 and $offset + $size <= $$dirInfo{DataLen}) {
@@ -5300,7 +6924,7 @@
             my $tagInfo = $self->GetTagInfo($tagTablePtr, $tagID);
             next unless defined $tagInfo;
-            while (@varInfo and $varInfo[0] < $tagID) {
+            while (@varInfo and $varInfo[0][0] < $tagID) {
+                $varSize = $varInfo[0][1];
                 shift @varInfo;
-                $varSize = shift @varInfo;
             }
             my $entry = int($tagID) * $increment + $varSize;
@@ -5316,5 +6940,5 @@
             next unless $$tagInfo{SubDirectory}; # (just to be safe)
             my %subdirInfo = ( DataPt => \$newData, DirStart => $entry );
-            my $subTablePtr = GetTagTable($tagInfo->{SubDirectory}{TagTable});
+            my $subTablePtr = GetTagTable($$tagInfo{SubDirectory}{TagTable});
             my $dat = $self->WriteDirectory(\%subdirInfo, $subTablePtr);
             substr($newData, $entry) = $dat if defined $dat and length $dat;
@@ -5331,4 +6955,5 @@
 {
     my ($self, $dirInfo, $tagTablePtr) = @_;
+    $self or return 1;    # allow dummy access
     my $buff = '';
     $$dirInfo{OutFile} = \$buff;
@@ -5356,5 +6981,5 @@
 =head1 AUTHOR
 
-Copyright 2003-2011, Phil Harvey (phil at owl.phy.queensu.ca)
+Copyright 2003-2021, Phil Harvey (philharvey66 at gmail.com)
 
 This library is free software; you can redistribute it and/or modify it
